//
// Landmark.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Landmark: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var envisionAssetId: Double?
    public var _class: String?
    public var confidence: Double?
    public var position: [Double]?
    public var updatedAt: Date?
    public var createdAt: Date?

    public init(id: Int? = nil, envisionAssetId: Double? = nil, _class: String? = nil, confidence: Double? = nil, position: [Double]? = nil, updatedAt: Date? = nil, createdAt: Date? = nil) {
        self.id = id
        self.envisionAssetId = envisionAssetId
        self._class = _class
        self.confidence = confidence
        self.position = position
        self.updatedAt = updatedAt
        self.createdAt = createdAt
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case envisionAssetId
        case _class = "class"
        case confidence
        case position
        case updatedAt
        case createdAt
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(envisionAssetId, forKey: .envisionAssetId)
        try container.encodeIfPresent(_class, forKey: ._class)
        try container.encodeIfPresent(confidence, forKey: .confidence)
        try container.encodeIfPresent(position, forKey: .position)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
    }
}

